/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var fireform_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.fireform.");
var fireform_prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

var fireform_debuglevel=-1;

function fireform_profile(desc,value,trigger,url)
{
this.desc=desc;
this.value=value;
this.trigger=trigger;
this.url=url;
} // profs

function fireform_getvaluebydesc(profile,desc)
{
for (var i in profile) 
	if (desc==profile[i].desc) return profile[i].value;
return null;   
}//getvaluebydesc

function fireform_computefields(profile)
{
//add computed fields
//this is uggly
var computed_field=fireform_getstring("computed_field.desc");
var birthday=fireform_getvaluebydesc(profile,fireform_getstring("birthday"));
var birthmonth=fireform_getvaluebydesc(profile,fireform_getstring("birthmonth"));
var birthyear=fireform_getvaluebydesc(profile,fireform_getstring("birthyear"));

if (birthday && birthmonth && birthyear)
{var bd=new Date();
var today=new Date();
birthmonth=(birthmonth+'').split(";")[0];
bd.setFullYear(birthyear,birthmonth-1,birthday);
var bdstring=fireform_getstring("birthday.value").replace("birthday",birthday).replace("birthmonth",birthmonth).replace("birthyear",birthyear);
var age=today.getFullYear()-bd.getFullYear(); 
if  ( (bd.getMonth()>today.getMonth()) || ((bd.getMonth()==today.getMonth()) && (bd.getDay()>=today.getMonth))) age--;
profile[profile.length]=new fireform_profile(computed_field,age,fireform_getstring("age.trigger"),"");
profile[profile.length]=new fireform_profile(computed_field,bdstring,fireform_getstring("birthday.trigger"),"");
}//if

}
function fireform_load1prof(profile,choice)
{

function fireform_getvalue(choice,num,field)
{ 
  if (fireform_prefs.prefHasUserValue("profiles.prof"+choice+".field"+num+"."+field))
	return fireform_prefs.getComplexValue("profiles.prof"+choice+".field"+num+"."+field,Components.interfaces.nsISupportsString).data;
  else 
    return "";
}
fireform_trace(0,"loading profile "+choice);

var j=1;
while (fireform_prefs.prefHasUserValue("profiles.prof"+choice+".field"+j+".desc")) 
{
profile[j]=new fireform_profile(fireform_getvalue(choice,j,"desc"),fireform_getvalue(choice,j,"value"),fireform_getvalue(choice,j,"trigger"),fireform_getvalue(choice,j,"url"));

fireform_trace(0,"retrieving profile : field"+j+" "+profile[j].desc+" "+profile[j].value+" "+profile[j].trigger+" "+profile[j].url);
j++; 
}// while j
if (j<profile.length) profile.splice(j,profile.length-j); //remove old rows
fireform_computefields(profile);

} //load1prof

function fireform_getstring(str)
{
    try  { return document.getElementById("fireform-strings").getString(str); }
    catch (ex)  { return null; }
}// fireform_getstring

function fireform_localert(msg)
{ 
var txt=document.getElementById("fireform-strings").getString(msg);
fireform_prompts.alert(window, "fireform", txt);
} // localert

function fireform_trace(level,msg) {

if (level>fireform_debuglevel) return;
var ConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
     getService(Components.interfaces.nsIConsoleService);

ConsoleService.logStringMessage("fireform : "+msg);
} // end trace