/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
fireform_trace(0,"fireform initiliaze...");
 
var fireform={
currentprof:new Array()
}; //fireform;

fireform.supertrim = function(s) { return s.replace(/^\s+|\s+$/g, "") }

fireform.lookthisnoderev=function(no)
{ 
if (!no) return null;
var ret=null;
while (no)
{
if (no.nodeName=="INPUT" || no.nodeName=="SELECT" || no.nodeName=="DIV") return ret;
var found=fireform.lookthisnoderev(no.lastChild); //recurse
if (found) { if (ret) ret=found+" "+ret; else ret=found;}

if (no.nodeValue)
{ found=fireform.supertrim(no.nodeValue);
  if (found!="") { if (ret) ret=found+ret; else ret=found;}
}//if    
no=no.previousSibling;
}//while
return ret;

}//lookthisnoderev

fireform.guessfieldname=function(fi)
{ 
 var found=fireform.lookthisnoderev(fi.previousSibling);
 if (!found)
 { var no=fi.parentNode;
   while (!no.previousSibling) no=no.parentNode;
   no=no.previousSibling;
   while ( !found && (no))
   { found=fireform.lookthisnoderev(no.lastChild);
     no=no.previousSibling;
   }//while
 }//if
return found;         
} //guessfieldname

fireform.lookthisnodefwd=function(no)
{ 
if (!no) return null;
var ret=null;
if (no.nodeValue)
{ var found=fireform.supertrim(no.nodeValue);
  if (found!="") return found; // { if (ret) ret=ret+found; else ret=found;}
}//if 
while (no)
{
var found=fireform.lookthisnodefwd(no.firstChild); //recurse
if (found) return found;//{ if (ret) ret=ret+" "+found; else ret=found;}
no=no.nextSibling;
}//while
return ret;

}//lookthisnodefwd

fireform.guessbuttonname=function(fi)
{ 
 
  var found=fireform.lookthisnodefwd(fi.nextSibling);
  if(!found)
  { var no=fi.parentNode;
   while (!no.nextSibling) no=no.parentNode;
   no=no.nextSibling;
   while ( !found && (no))
   { found=fireform.lookthisnodefwd(no.firstChild);
     no=no.nextSibling;
   }//while
  }//if 
 //if (!found) found=fireform.lookthisnodefwd(fi.nextSibling);   
return found;         
} //guessbuttonname

fireform.display1field=function(fi)
{
if (fi.type=="radio" || fi.type=="checkbox") var guessedname=fireform.guessbuttonname(fi); 
else var guessedname=fireform.guessfieldname(fi); 
fi.setAttribute("style", "background-color:lightblue;");
fi.title="fireform : ["+fireform_getstring("fieldname")+"="+fi.name+"]";
if (fi.type=="radio" || fi.type=="checkbox") fi.title+="["+fireform_getstring("value")+"="+fi.value+"]";
fi.title+="["+fireform_getstring("guessed_name")+"="+guessedname+"]";
}// display1field

fireform.DisplayFields=function(win,depth)
{
var found=false;

var formElements = win.document.getElementsByTagName("select");
for (var i = 0; i < formElements.length; i++) 
     { fireform.display1field(formElements[i]);
       found=true;
  }//for i   
  
var formElements = win.document.getElementsByTagName("input");
for (var i = 0; i < formElements.length; i++) 
      {
	if (formElements[i].type=="text" || formElements[i].type=="password" || formElements[i].type == "radio" || formElements[i].type=="checkbox" || formElements[i].type=="file")
         { fireform.display1field(formElements[i]);
          found=true;
         } //if
      } //for

var formElements = win.document.getElementsByTagName("textarea");
for (var i = 0; i < formElements.length; i++) 
      {
       fireform.display1field(formElements[i]);
          found=true;
      } //for
            
// recurse
	var frames = win.document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++)
		if (this.DisplayFields(frames[i].contentWindow,depth+1)) found=true;
	var frames = win.document.getElementsByTagName("iframe");
	for (var i = 0; i < frames.length; i++) 
	    if (this.DisplayFields(frames[i].contentWindow,depth+1)) found=true;
if (depth==0)
{ if (found) fireform_localert("dispfields")
  else fireform_localert("nodispfield");
}//if		
return found;
} // end DisplayFields

fireform.match1field=function(name,currenturl)
{
var match=1000;
	var newvalue=null;
	for(var j in this.currentprof)
	{
	urlfound=false; 
	if (this.currentprof[j].url!="") // check url
	{  
	   var urlist=this.currentprof[j].url.toLowerCase().split(";");
	   for (var u in urlist)
	         if (currenturl.toLowerCase().indexOf(urlist[u])==0) {urlfound=true; break;}
	   if (!urlfound) continue;
	} // check url   
	var s2=this.currentprof[j].trigger.toLowerCase().split(";")
	for(var p in s2)
	{
     if (s2[p].length>0)
	 if (name.indexOf(s2[p])>=0) { 
 				if ( ((name.length-s2[p].length)<match) // found
 				   || ( urlfound && ((name.length-s2[p].length)==match) ) )
				{match=name.length-s2[p].length;
				newvalue=this.currentprof[j].value+''; //always string
				} //if
				} //if
     } // for p
} //for j
return newvalue; 
}//match1field

fireform.matchfield=function(fi,currenturl)
{
var ret=fireform.match1field(fi.name.toLowerCase(),currenturl); //try with real field name
if (ret!=null) return ret;
// then try with guessed name
if (fi.type=="button" || fi.type=="checkbox") var gname=fireform.guessbuttonname(fi); else var gname=fireform.guessfieldname(fi);
if (gname) return fireform.match1field(gname.replace(" ","").toLowerCase(),currenturl);

return null;
}//matchfield

fireform.FillFields=function(win,depth)
{ 

if (!fireform_prefs.prefHasUserValue("currentprofile")) // first run
{
fireform_prefs.setCharPref("currentprofile",0);
fireform_trace(0,"fireform welcome message");    
fireform_localert("welcome");
window.open("chrome://fireform/content/simplesetup.xul", "", "chrome,resizable=yes,alwaysRaised=true");
return false;
}//if

var found=false;
if (depth==0)
 { var currentprofile=0;
  if (fireform_prefs.prefHasUserValue("currentprofile")) currentprofile=fireform_prefs.getCharPref("currentprofile");
  if (currentprofile<=0) { fireform_localert("noprofile"); return found;}
  fireform_load1prof(this.currentprof,currentprofile);
  
//look for temporary triggers
//https?
if (win.location.protocol!="https:")
{
var params = win.location.search.substring(1).split("&");
newtrig=newval=newurl=null;
for (var i in params) {
   var onevar = params[i].split("=");
   if (onevar[0]=="fireform-trig") newtrig=unescape(onevar[1]);
   if (onevar[0]=="fireform-val") newval=unescape(onevar[1]);
   if (onevar[0]=="fireform-url") newurl=unescape(onevar[1]);
   if (newtrig && newval) 
      { if (newurl==null) newurl="";
        this.currentprof[this.currentprof.length]=new fireform_profile("fireform-temp",newval,newtrig,newurl);
        newval=newtrig=newurl=null;
      }  //if
} //for
} //if
}//if depth

var formElements = win.document.getElementsByTagName("select");
     for (var i = 0; i < formElements.length; i++) 
		{ var newvalue=fireform.matchfield(formElements[i],win.location.toString());
		  foundb=false;
		  if (newvalue) //found
			{
				var s2=newvalue.toLowerCase().split(";");
				// exact match
				for (var j = 0; j < formElements[i].options.length && !foundb; j++) 
				{
			     for(var p in s2)
			       if (formElements[i].options[j].text.toLowerCase()==s2[p]) 
			       {formElements[i].selectedIndex=j;
			        formElements[i].setAttribute("style", "background-color:lightgreen;");
			        found=foundb=true;
			        break;
			       } //if
				} //for j

				// loose (substring) match for select's options
				if (!foundb)
					for (var j = 0; j < formElements[i].options.length && !foundb; j++) 
					{
				     for(var p in s2)
				       if (formElements[i].options[j].text.toLowerCase().indexOf(s2[p]) >=0 ) 
				       {formElements[i].selectedIndex=j;
				        formElements[i].setAttribute("style", "background-color:lightgreen;");
				        found=foundb=true;
				        break;
				       } //if
					} //for j

			}
		} //for i  
		
var formElements = win.document.getElementsByTagName("input");
      for (var i = 0; i < formElements.length; i++) 
      { 
      if (formElements[i].type=="text" || formElements[i].type=="password" || formElements[i].type=="file")
	    { // try to fill in
	  
			var newvalue=fireform.matchfield(formElements[i],win.location.toString());
			if (newvalue) // found
			{ 	
				if (this.overwrite_option || (formElements[i].value=="")) // take care of overwrite
				{
			    formElements[i].setAttribute("style", "background-color:lightgreen;");
			    formElements[i].value=newvalue.split(";")[0];
			    }
				found=true;
			}       // if match
         } //if
           
        if ( formElements[i].type == "radio" || formElements[i].type =="checkbox" )
        { var newvalue=fireform.matchfield(formElements[i],win.location.toString());
          if (newvalue) // found
          { var s2=newvalue.replace(/\s/g,"").toLowerCase().split(";")
            var gbname=formElements[i].value;
            foundb=false;
            if (gbname)
			{ gbname=gbname.replace(/\s/g,"").toLowerCase();
				// exact match
	            for (var p in s2)
			    {  if (s2[p]==gbname) //found
				   {formElements[i].setAttribute("style", "background-color:lightgreen;");
					formElements[i].checked=true;
					found=foundb=true;
					break;
				   }  // if s2[p]
				}// for p in s2
				
				if (!foundb)
				{
					// substring match
		            for (var p in s2)
				    {  if (gbname.indexOf(s2[p]) >= 0) //found
					   {formElements[i].setAttribute("style", "background-color:lightgreen;");
						formElements[i].checked=true;
						found=foundb=true;
						break;
					   }  // if s2[p]
					}// for p in s2
				} // !foundb

			} // if gbname


			if (!foundb)
			{ 
            var gbname1=fireform.guessbuttonname(formElements[i]);
            if (gbname1)
				{ gbname1=gbname1.replace(/\s/g,"").toLowerCase();
				  for (var p in s2)
		             if (s2[p]==gbname1) //found
					   {formElements[i].setAttribute("style", "background-color:lightgreen;");
						formElements[i].checked=true;
						found=foundb=true;
						break;
					  }//if s2[p]

					if (!foundb)
					{
						// substring match
			            for (var p in s2)
					    {  if (gbname1.indexOf(s2[p]) >= 0) //found
						   {formElements[i].setAttribute("style", "background-color:lightgreen;");
							formElements[i].checked=true;
							found=foundb=true;
							break;
						   }  // if s2[p]
						}// for p in s2
					} // !foundb



				} //if gbname1
			} //foundb  
 

         }//if newvalue
        }//if type
       } // for i  

var formElements = win.document.getElementsByTagName("textarea");
for (var i = 0; i < formElements.length; i++) 
	   {var newvalue=fireform.matchfield(formElements[i],win.location.toString());
		 if (newvalue) // found
			{ 	
				if (this.overwrite_option || (formElements[i].value=="")) // take care of overwrite
				{
				formElements[i].setAttribute("style", "background-color:lightgreen;");
			    formElements[i].value=newvalue.split(";")[0];
			    }
				found=true;
			}       // if match
       } // for
       
// recurse
	var frames = win.document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++)
		if (this.FillFields(frames[i].contentWindow,depth+1)) found=true;
	var frames = win.document.getElementsByTagName("iframe");
	for (var i = 0; i < frames.length; i++)
		if (this.FillFields(frames[i].contentWindow,depth+1)) found=true;
if ((depth==0) && !found) fireform_localert("unable");
return found;
	
} // end FillFields

fireform.select=function(num)
{
fireform_prefs.setCharPref("currentprofile",num);
} //select

fireform.menupopup=function(button)
{
if (fireform_prefs.prefHasUserValue("currentprofile")) 
{
var liste=button.childNodes;
for(var n=1;liste.item(n).nodeName!="menuseparator";n++);
while (liste.length>n+1) button.removeChild(liste.item(n+1)); //remove old menu

var currentprofile=fireform_prefs.getCharPref("currentprofile");
var i=1;
while (fireform_prefs.prefHasUserValue("profiles.prof"+i+".name"))
{var name=fireform_prefs.getCharPref("profiles.prof"+i+".name");
var menu=document.createElement("menuitem");menu.id="prof"+i;menu.setAttribute("label",name);
if (i==currentprofile) menu.setAttribute("style","font-weight:bold");
menu.setAttribute("oncommand","fireform.select("+i+")");
button.appendChild(menu);
i++;
}//while
}//if

return true;
}//menupopup

fireform.delete_all=function()
{ // should be called when uninstalling...
var prefsall= Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.");
prefsall.deleteBranch("fireform");
}

var myObserver = {
    observe : function ( subject , topic , data ){
    if (topic == "em-action-requested") {
		subject.QueryInterface(Components.interfaces.nsIUpdateItem);
		if (subject.id == "fireform@mozilla.org") {
		  if (data=="item-uninstalled") fireform.delete_all() // remove all keys
        }
    }       
  }
 }  //myObserver

//initialisation
var ObserverServ = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
ObserverServ.addObserver ( myObserver , "em-action-requested" , false );

fireform.showupdatepage=function()
{ //open the update page in a new tab
try  { var generalprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("general.");
          var locale=generalprefs.getCharPref("useragent.locale"); }
catch (ex)  { locale="en";}
if (!(locale=="fr")) locale="en"; //french only currently...
var updateurl="http://fireform.free.fr/updates/"+locale+"/04_update.html"; 
getBrowser().selectedTab=getBrowser().addTab(updateurl);
}

fireform.updated=function()
{ //called on extension update
   setTimeout(function() {fireform.showupdatepage()},1000); //don't open the tab too early, or it will disappear
}

var ffversion="0.0";
if (fireform_prefs.prefHasUserValue("fireformversion")) ffversion=fireform_prefs.getCharPref("fireformversion");
if (ffversion != "0.4") // fireform was installed or updated - open updatepage
  { 
   fireform_prefs.setCharPref("fireformversion", "0.4");
   window.addEventListener("load", fireform.updated,false);
   }