/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var fireform_setup={
profs:new Array(),
profsnames:new Array(),
currentprofile:0,
groups:new Array(),
version:0,
option_overwrite:false
}; //fireform_setup;

function fireform_setup_group(name,childs)
{
this.name=name;
this.childs=childs;
}

fireform_setup.addcopy_profile=function(option)
{ // add or copy a profile

if ((option=="copy") && (this.currentprofile<1)) return; // no profile yet
var oldprofile=this.currentprofile;

var doc=document.getElementById("fireform-strings");
// ask for name

var newprof = {value: ""};
var check = {value: false};

do {
if (!fireform_prompts.prompt(window, doc.getString("create_profile_title"), doc.getString("ask_profile_name"), newprof, null, check)) return;
var ok=true;
for (var p in this.profsnames) if (this.profsnames[p]==newprof.value) ok=false;
if (!ok) fireform_localert("already_exists");
} while (!ok);

this.currentprofile=this.profs.length;
if (this.currentprofile==0) this.currentprofile=1;
this.profsnames[this.currentprofile]=newprof.value;
var list=document.getElementById("profile_list");
list.appendItem(newprof.value,newprof.value);
list.selectedIndex=document.getElementById("prof_menu").childNodes.length-1;

if (option=="copy") 
{ this.profs[this.currentprofile]=new Array();
  for (var o in this.profs[oldprofile]) 
  this.profs[this.currentprofile][o]=new fireform_profile(this.profs[oldprofile][o].desc,this.profs[oldprofile][o].value,this.profs[oldprofile][o].trigger,this.profs[oldprofile][o].url); //clone
}
else
{
	this.profs[this.currentprofile]=new Array();
	var i=1;
	while (fireform_getstring("default.field"+i+".desc")!=null) //setup default values
	{
	this.profs[this.currentprofile][i]=new fireform_profile(doc.getString("default.field"+i+".desc"),doc.getString("default.field"+i+".value"),doc.getString("default.field"+i+".trigger"),"");
	i++;
	} //while
}	
this.display_profile();

}//addcopy_profile

fireform_setup.clear_fields=function()
{
 for(var i in this.profs[this.currentprofile])
   {this.profs[this.currentprofile][i].desc="";
   this.profs[this.currentprofile][i].value="";
   this.profs[this.currentprofile][i].trigger="";
   this.profs[this.currentprofile][i].url="";}
this.display_profile();

}// clear_fields

fireform_setup.export_profiles=function()
{

var doc =document.getElementById("fireform-strings");
var xmldoc = document.implementation.createDocument("", "", null);
xmldoc.async = false; 
var ff=xmldoc.createElement('fireform_profiles');

for(var i in this.profsnames) 
{ var pname=xmldoc.createElement('profile');
  pname.setAttribute("name", this.profsnames[i]);
  for(var j in this.profs[i])
    if (this.profs[i][j].desc+this.profs[i][j].value+this.profs[i][j].trigger!="")
    {
      var field=xmldoc.createElement('field');
      field.setAttribute("desc", this.profs[i][j].desc);
      field.setAttribute("value", this.profs[i][j].value);
      field.setAttribute("trigger", this.profs[i][j].trigger);
      field.setAttribute("url", this.profs[i][j].url);
      pname.appendChild(field);
    }
ff.appendChild(pname);
}
xmldoc.appendChild(ff);

var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
fp.init(window, doc.getString("exportfile"), nsIFilePicker.modeSave);
fp.appendFilters(nsIFilePicker.filterXML,"xml","xml");
//fp.appendFilter("fireform profiles (xml)","*.xml");
fp.defaultExtension="xml";
fp.defaultString=".xml";
var res = fp.show();
if (res == nsIFilePicker.returnCancel) return;

var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);

foStream.init(fp.file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate

var xmls = new XMLSerializer();
xmls.serializeToStream(xmldoc,foStream,"UTF-8");
foStream.close();

var msg=new Array();msg[0]=this.profs.length-1;
alert(doc.getFormattedString("profilesexported",msg));  

} //export_profiles

fireform_setup.import_profiles=function()
{
var doc =document.getElementById("fireform-strings");

var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
fp.init(window, doc.getString("importfile"), nsIFilePicker.modeOpen);
fp.appendFilters(nsIFilePicker.filterXML);

//fp.appendFilter("fireform profiles (xml)","*.xml");
var res = fp.show();
if (res == nsIFilePicker.returnCancel) return;

var fistream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
fistream.init(fp.file, -1, 0, 0);

var parser = new DOMParser();
var xmldoc = parser.parseFromStream(fistream, 0 , 1000000, "text/xml");
fistream.close();

var nbprof=this.profs.length; 
var nbimported=0;
if (nbprof==0) nbprof=1;
var root = xmldoc.getElementsByTagName('fireform_profiles');
for ( i =0;i<root.length;i++)
   {
   var p=root.item(i).firstChild;
   while (p) { //for each profile
     var newname=p.getAttribute('name');
     var ok=true;
     for (var pr in this.profsnames) if (this.profsnames[pr]==newname) ok=false; 
     if (!ok)
     { var msg=new Array(newname);
       alert(doc.getFormattedString("profnotimported",msg));
     } //ok
     else
     {
		this.profsnames[nbprof]=newname;
		document.getElementById("profile_list").appendItem(newname,newname);  
		this.profs[nbprof]=new Array();        
		var f=p.firstChild;
		j=0;
		while (f) { // for each field
			this.profs[nbprof][j]=new fireform_profile(f.getAttribute('desc'),f.getAttribute('value'),f.getAttribute('trigger'),f.getAttribute('url'));
			f=f.nextSibling;
			j++;
			} // while f
		nbprof++;
		nbimported++;
	 }//ok
		p=p.nextSibling;
    } //while p
    } //for i
var msg=new Array();msg[0]=nbimported;
alert(doc.getFormattedString("profilesimported",msg));   
if ((this.currentprofile<=0) && (nbimported>0))
	{ document.getElementById("profile_list").selectedIndex=0;
	  this.select_profile();
	}

} //import_profiles


fireform_setup.del_profile=function()
{
if (this.currentprofile<=0) return;
delete this.profsnames[this.currentprofile];
delete this.profs[this.currentprofile];

var list=document.getElementById("profile_list");
var i=list.selectedIndex;
list.removeItemAt(i);
var max=document.getElementById("prof_menu").childNodes.length-1;
if (i>max) i=max;
list.selectedIndex=i;
this.select_profile();
} //delete_profile

fireform_setup.delall_profiles=function()
{
for (var i in this.profs) { delete this.profs[i];delete this.profsnames[i];}
var list=document.getElementById("profile_list");
while (document.getElementById("prof_menu").childNodes.length>0) list.removeItemAt(0);
list.selectedIndex=0;
this.select_profile();
} //delall_profiles

fireform_setup.display_profile=function()
{

fireform_setup.create_line=function(attrib,label,i,val)
{
var clone=model.cloneNode(true);
clone.childNodes[0].setAttribute("value",label);
clone.childNodes[1].setAttribute("value",val);
if (disable) clone.childNodes[1].setAttribute("disabled", "true");
clone.childNodes[1].setAttribute("onchange", "fireform_setup.profs[fireform_setup.currentprofile]["+i+"]."+attrib+"=event.target.value");
return clone;
}// create line

if (!document.getElementById("fireform_setup_dialog")) {fireform_setup.display_simple_profile();return;}
var rows=document.getElementById("rows");

// create a template box
var model=document.createElement("hbox");model.setAttribute("flex","1");
var lb=document.createElement("label");lb.setAttribute("control","textbox");
var tb=document.createElement("textbox");tb.id="textbox";tb.setAttribute("flex","1");
model.appendChild(lb);
model.appendChild(tb);

var cp=this.profs[this.currentprofile];

while(rows.firstChild) rows.removeChild(rows.firstChild); //remove previous display
if (this.currentprofile>0)
{
for (var i=0;i<30;i++) cp[cp.length]=new fireform_profile("","","",""); // add empty lines
	
var computed_field=fireform_getstring("computed_field.desc");
var desc_label=fireform_getstring("label.desc");
var value_label=fireform_getstring("label.value");
var trigger_label=fireform_getstring("label.trigger");
var url_label=fireform_getstring("label.url");

for(i in this.profs[this.currentprofile])
{
var disable=(cp[i].desc==computed_field);

var gb=document.createElement("groupbox");gb.setAttribute("orient","vertical");
var row1=document.createElement("hbox");row1.setAttribute("flex","1");

var hb=fireform_setup.create_line("desc",desc_label,i,this.profs[this.currentprofile][i].desc);
row1.appendChild(hb);

var hb=fireform_setup.create_line("url",url_label,i,this.profs[this.currentprofile][i].url);
row1.appendChild(hb);

var hb=fireform_setup.create_line("value",value_label,i,this.profs[this.currentprofile][i].value);
row1.appendChild(hb);

var hb=fireform_setup.create_line("trigger",trigger_label,i,this.profs[this.currentprofile][i].trigger);

gb.appendChild(row1);
gb.appendChild(hb);

rows.appendChild(gb);


} //for i
}//if

} //display_profile

fireform_setup.display_simple_profile=function()
{

var grbase=document.getElementById("grbase");
while(grbase.firstChild) grbase.removeChild(grbase.firstChild); //remove previous display

var cp=this.profs[this.currentprofile];
var cc=true;
for(var i in this.groups) 
{
if (cc) {container=document.createElement("hbox");container.id="cont"+i;container.setAttribute("flex","1");
document.getElementById("grbase").appendChild(container);}
cc=!cc;

var gr=document.createElement("groupbox");gr.id="group"+i;gr.setAttribute("flex","1");
var cap=document.createElement("caption");cap.id="cap"+i;//cap.setAttribute("flex","1");
cap.setAttribute("label",this.groups[i].name);
gr.appendChild(cap);
	for (var j in cp)
	{if ((cp[j].desc) && ((";"+this.groups[i].childs+";").toLowerCase().indexOf(";"+cp[j].desc.toLowerCase()+";"))>=0)
	  {
	  var hbox=document.createElement("hbox");hbox.id="hbox"+j;//hbox.setAttribute("flex","1");
	  var lab=document.createElement("label");lab.id="lab"+j;//lab.setAttribute("flex","1");
	  lab.setAttribute("value",cp[j].desc+" : ");
	  lab.setAttribute("control","box"+j);
	  hbox.appendChild(lab);
	  var tb=document.createElement("textbox");tb.id="box"+j;tb.setAttribute("flex","1");
	  tb.setAttribute("class","input");
	  tb.setAttribute("type","text");
	  tb.setAttribute("value",cp[j].value.split(";")[0]);
	  tb.setAttribute("onchange", "fireform_setup.profs[fireform_setup.currentprofile]["+j+"].value=event.target.value");
	  hbox.appendChild(tb);
	  gr.appendChild(hbox);
	  }//if
	}//for j
container.appendChild(gr);
}//for

} //display_simple

fireform_setup.select_profile=function()
{ 
this.currentprofile=0;
for(var i in this.profsnames)
 if (this.profsnames[i]==document.getElementById("profile_list").value) {this.currentprofile=i;break;}
this.display_profile();
}//select_profile

fireform_setup.load_groups=function()
{
var i=1;
var gr;
while ((gr=fireform_getstring("default.group"+i+".name"))!=null) 
{
this.groups[i]=new fireform_setup_group(gr,fireform_getstring("default.group"+i+".childs"));
i++;
}//while
}//load_groups

fireform_setup.load_profiles=function()
{
fireform_setup.load_groups();
var nbprofs=0;

while (fireform_prefs.prefHasUserValue("profiles.prof"+(nbprofs+1)+".name")) 
{
nbprofs++;
this.profs[nbprofs]=new Array();
this.profsnames[nbprofs]=fireform_prefs.getCharPref("profiles.prof"+nbprofs+".name");
document.getElementById("profile_list").appendItem(this.profsnames[nbprofs],this.profsnames[nbprofs]);

fireform_setup.load_options();
fireform_load1prof(this.profs[nbprofs],nbprofs);

}// while nbprofs

this.currentprofile=0;
if (fireform_prefs.prefHasUserValue("currentprofile")) 
 { 
  this.currentprofile=parseInt(fireform_prefs.getCharPref("currentprofile"));
  document.getElementById("profile_list").selectedIndex=this.currentprofile-1;
  this.display_profile();
 }
if (fireform_prefs.prefHasUserValue("version")) this.version=fireform_prefs.getCharPref("version");
else this.version="0.0";
// if (this.version<"0.3")  fireform_localert("oldprofile"); // bug on macintosh?

}//load_profiles
			

fireform_setup.save_profiles=function()
{
var calmonths=fireform_getstring("calendar_months").split(";");
var computed_field=fireform_getstring("computed_field.desc");
var unicodestr = Components.classes["@mozilla.org/supports-string;1"] .createInstance(Components.interfaces.nsISupportsString);


fireform_prefs.deleteBranch("profiles");
var profnum=0;
var newcurrent=0;
for(var i in this.profs)
{ 
profnum++;
if (i==this.currentprofile) newcurrent=profnum;
fireform_prefs.setCharPref("profiles.prof"+profnum+".name",this.profsnames[i]);
var fieldnum=0;
var cp=this.profs[i];
for(var j in cp)
{
if (!document.getElementById("fireform_setup_dialog")) 
{// simple setup, complete some fields, not nice but works...
 if (cp[j].desc==fireform_getstring("birthmonth")) 
 { var birthmonth=(cp[j].value+'').split(";")[0];
   cp[j].value=birthmonth;
   if ((birthmonth<10) && (birthmonth>0)) cp[j].value+=";"+parseInt(birthmonth);
   if ((birthmonth<=12) && (birthmonth>0)) cp[j].value+=";"+calmonths[birthmonth-1];
 } //if
 if (cp[j].desc==fireform_getstring("title"))
   { var title=cp[j].value.split(";")[0];
     var st=fireform_getstring("short_title."+title.toLowerCase());
     if (st) cp[j].value=title+";"+st;
   }//if
}//complete 

if ((cp[j].desc!=computed_field) && (cp[j].desc+cp[j].value+cp[j].trigger!=""))
 {  fieldnum++;
 
    unicodestr.data = cp[j].desc;
	fireform_prefs.setComplexValue("profiles.prof"+profnum+".field"+fieldnum+".desc", Components.interfaces.nsISupportsString, unicodestr);
	unicodestr.data = cp[j].value;
	fireform_prefs.setComplexValue("profiles.prof"+profnum+".field"+fieldnum+".value", Components.interfaces.nsISupportsString, unicodestr);
	unicodestr.data = cp[j].trigger;
	fireform_prefs.setComplexValue("profiles.prof"+profnum+".field"+fieldnum+".trigger", Components.interfaces.nsISupportsString, unicodestr);
	unicodestr.data = cp[j].url;
	fireform_prefs.setComplexValue("profiles.prof"+profnum+".field"+fieldnum+".url", Components.interfaces.nsISupportsString, unicodestr);
 }
}// for j
}// for i

fireform_prefs.setCharPref("version", "0.4");
fireform_prefs.setCharPref("currentprofile",newcurrent);
fireform_setup.save_options();
window.close();

}//save_profiles

fireform_setup.set_option=function(option,value)
{// sets an optional field
if (option=="overwrite") this.option_overwrite=value;
}

fireform_setup.load_options=function(option,value)
{// load options
this.option_overwrite=false;
if (fireform_prefs.prefHasUserValue("option.overwrite")) this.option_overwrite=fireform_prefs.getBoolPref("option.overwrite");
document.getElementById("overwrite_fields").checked=this.option_overwrite;
}

fireform_setup.save_options=function(option,value)
{// save options
 this.option_overwrite=fireform_prefs.setBoolPref("option.overwrite",this.option_overwrite);
}